// --------------
// App.cpp
// This is compiled as an EXE
// --------------

#include <windows.h>
#include "DLLInterface.h"

// Actual funcionality provided by the app.
class CAppImplementation: public IAppInterface
{
public:
  int Operation(int parm) { return parm*2; }
};

void main()
{
  HMODULE hDLL = ::LoadLibrary("DLL");
  FuncCreateDLLInterface createFunc = (FuncCreateDLLInterface)::GetProcAddress(hDLL, "CreateDLLInterface");

  CAppImplementation App;
  IDLLInterface *pDLL = createFunc(&App);
  pDLL->MyDLLFunction(10); //Calls the DLL, which in turn calls the app back.
}

