// --------------
// DLL.cpp
// This is compiled as a DLL
// --------------

#include <windows.h>
#include <stdio.h>

#define __DO_DLL_EXPORT__
#include "DLLInterface.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					           )
{
    return TRUE;
}


// Actual funcionality provided by the DLL.
class CDLLImplementation: public IDLLInterface
{
  IAppInterface *m_pApp;
public:
  CDLLImplementation(IAppInterface *pApp): m_pApp(pApp) { }
  void MyDLLFunction(int parm) { printf("Yes, %d\n", m_pApp->Operation(parm)); }
  // ...
};

IDLLInterface *CreateDLLInterface(IAppInterface *pApp)
{
  static CDLLImplementation dllImpl(pApp);
  return &dllImpl;
}
